<template>
    <q-item style="box-sizing: border-box">
        <q-item-section>
            <q-item-label>{{ activeRule.rule.name }}</q-item-label>
            <q-item-label caption> {{ activeRule.rule.description }}</q-item-label>
        </q-item-section>
        <q-item-section avatar>
            <q-toggle icon="alarm" :value="Subscribed" @input="SubscribeToggle"/>
            <q-btn flat icon="delete" @click='dialog=true' color="negative"/>
        </q-item-section>
        <q-dialog v-model="dialog" persistent>
            <RemoveRuleFromFloorDialog
                class="q-pa-lg"
                @remove="Remove"
                :active-rule="activeRule"
                @back="dialog = false"
            />
        </q-dialog>
    </q-item>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {ActiveRuleResponse} from "src/classLibrary/APIModels/core/activeRuleResponse";
import RemoveRuleFromFloorDialog from "components/Dialog/RemoveRuleFromFloorDialog.vue";

@Component({
    components: {RemoveRuleFromFloorDialog}
})
export default class ActiveRuleItem extends Vue {
    @Prop() activeRule!: ActiveRuleResponse;

    dialog = false;

    get Subscribed() {
        return this.activeRule.subscribedUsers.Has(this.$coreAuth.user?.principal.id ?? "");
    }

    Remove() {
        this.dialog = false;
        this.$emit('remove');
    }

    SubscribeToggle(e: any) {
        this.$emit('subscribe', this.activeRule, e)
    }


}
</script>
